let read1 bsize filename =
  let s = String.create bsize in
  let f = Unix.openfile filename [Unix.O_RDONLY] 0 in
  let n = ref 1 in
  while !n > 0 do
    n := Unix.read f s 0 bsize
  done;
  Unix.close f

let read2 bsize filename =
  let m = Netsys_mem.alloc_memory_pages bsize in
  let f = Unix.openfile filename [Unix.O_RDONLY] 0 in
  let n = ref 1 in
  while !n > 0 do
    n := Netsys_mem.mem_read f m 0 bsize
  done;
  Unix.close f

let () =
  let n = ref 1 in
  let f = ref read1 in
  let blocksize = ref 4096 in
  let file = ref "" in
  Arg.parse
    [ "-mem", Arg.Unit (fun () -> f := read2),
      "  use mem_read";
      
      "-n", Arg.Set_int n,
      "<n>   number of iteration";

      "-blocksize", Arg.Set_int blocksize,
      "<n>   set the block size";
    ]
    (fun s -> file := s)
    "usage: s.opt file";
  
  let t0 = Unix.gettimeofday() in
  for i = 1 to !n do
    !f !blocksize !file
  done;
  let t1 = Unix.gettimeofday() in

  Printf.printf "time: %f\n" (t1-.t0)
